'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.user = undefined;
exports.sendEvent = sendEvent;
exports.sendException = sendException;

var _universalAnalytics = require('universal-analytics');

var _universalAnalytics2 = _interopRequireDefault(_universalAnalytics);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _version = require('../version');

var _version2 = _interopRequireDefault(_version);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const user = exports.user = _config2.default.analytics ? (0, _universalAnalytics2.default)('UA-81182461-1', { https: true }) : null;

function sendEvent(eventCategory, eventAction, eventLabel = null, eventValue = null) {
	if (user) {
		user.event({
			ec: eventCategory,
			ea: eventAction,
			el: eventLabel,
			ev: eventValue,
			an: 'RPBot',
			av: _version2.default
		}).send();
	}
}

function sendException(err) {
	if (user) {
		user.exception({
			exd: `${ err.name }: ${ err.message }`,
			an: 'RPBot',
			av: _version2.default
		}).send();
	}
}
//# sourceMappingURL=analytics.js.map
